//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
//|                                                                   bs-PSI@MAMs.mqh |
//|                                       Copyright  2012, Igor Stepovoi aka TarasBY |
//|                                                                taras_bulba@tut.by |
//|  30.08.2012      MA.                               |
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
//|        .  -  |
//|      (TarasBY).      |
//|       ,      .  |
//|      .                              |
//|         ,    - |
//| .                                                            |
//|     ,    ,    |
//|     Skype: TarasBY  e-mail.                           |
//+-----------------------------------------------------------------------------------+
//|   This product is intended for non-commercial use.  The publication is only allo- |
//|wed when you specify the name of the author (TarasBY). Edit the source code is va- |
//|lid only under condition of preservation of the text, links and author's name.     |
//|   Selling a module or(and) parts of it PROHIBITED.                                |
//|   The author is not liable for any damages resulting from the use of a module.    |
//|   For all matters relating to the work of the module, comments or suggestions for |
//|their improvement in the contact Skype: TarasBY or e-mail.                         |
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
#property copyright "Copyright  2008-12, TarasBY WM R418875277808; Z670270286972"
#property link      "taras_bulba@tut.by"
//IIIIIIIIIIIIIIIIIII==================CONSTANS=================IIIIIIIIIIIIIIIIIIIIII+
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
//|                 *****                  *****                   |
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
extern string Setup_MAMs           = "************** Send/Close MAM`s ****************";
/*extern*/ int    USE_MA                  = 1;           // 0 - off; 1 - send; 2 - close; 3 - send + close
extern int    Use_ChangeTrend.MA      = 0;           // 0 - off;     : 1 -   ; 2 -    ; 3 -  
extern double MA_K_Period             = 3.0;         //    2- .
extern int    MA_Period               = 14;
/*extern*/ int    MA_Shift                = 0;
extern int    MA_Method               = 7;
              // 0  - "SMA";
              // 1  - "EMA";
              // 2  - "Wilder";
              // 3  - "LWMA";
              // 4  - "SineWMA";
              // 5  - "TriMA";
              // 6  - "LSMA";
              // 7  - "SMMA";
              // 8  - "HMA";
              // 9  - "ZeroLagEMA";
              // 10 - "DEMA";
              // 11 - "T3";
              // 12 - "ITrend";
              // 13 - "Median";
              // 14 - "GeoMean";
              // 15 - "REMA";
              // 16 - "ILRS";
              // 17 - "IE/2";
              // 18 - "TriMAgen";
              // 19 - "VWMA";
              // 20 - "JSmooth";
extern int    MA_Price                = 7;
              // 0 - "Close";
              // 1 - "Open";
              // 2 - "High";
              // 3 - "Low";
              // 4 - "Median";
              // 5 - "Typical";
              // 6 - "Weighted Close";
              // 7 - "Heiken Ashi Close";
              // 8 - "Heiken Ashi Open";
              // 9 - "Heiken Ashi High";
              // 10 - "Heiken Ashi Low";
/*extern*/ int    Color_Mode               = 0;
//IIIIIIIIIIIIIIIIIII=========  =======IIIIIIIIIIIIIIIIIIIIII+
//IIIIIIIIIIIIIIIIIII========  =======IIIIIIIIIIIIIIIIIIIIII+
int           bia_PeriodMA[2];
//IIIIIIIIIIIIIIIIIII===========  =========IIIIIIIIIIIIIIIIIIIIII+
/*int fGet_SignalMA (string fs_Symbol,                   // Symbol
                     int fi_TF,                          // 
                     double fd_Deviation = 0,            //  \ 
                     int fi_BarSignal = 1,               //     
                     bool fb_ControlBeginChangeTrend = False,//    
                     int fi_VerificationBars = 1)*/      //     
                            //     MAHA    2- MA
/*double fControl_Deviation (double ar_MA[],             //   
                             bool& fb_Condition,         //  
                             int& fi_cmd,                // " "
                             int& fi_Trend,              // 
                             double fd_Deviation = 0)*/  //  \ 
                            //   2-    1- 
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
//|   : TarasBY, taras_bulba@tut.by                                              |
//+-----------------------------------------------------------------------------------+
//|            MAHA    2- MA                  |
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
int fGet_SignalMA (string fs_Symbol,                        // Symbol
                   int fi_TF,                               // 
                   double fd_Deviation = 0,                 //  \ 
                   bool fb_ControlBeginChangeTrend = False, //    
                   int fi_BarSignal = 1,                    //     
                   int fi_VerificationBars = 1)             //     
{
    static int li_preSignal = STOP;
    double lda_MA[2];
    bool   lb_twice = (MA_K_Period > 1.0), lb_Condition;
    int    li_BAR = fi_BarSignal, li_Trend = STOP, li_VerificationBars = 0, li_cmd = 1;
//----
    //----    2- 
    if (lb_twice)
    {
        for (int li_IND = 0; li_IND < 2; li_IND++)
        {lda_MA[li_IND] = iCustom (fs_Symbol, fi_TF, "AllAverages_v2.51", fi_TF, bia_PeriodMA[li_IND], MA_Shift, MA_Method, MA_Price, Color_Mode, 0, li_BAR);}
        //----  1-     
        double ld_Deviation = fControl_Deviation (lda_MA, lb_Condition, li_cmd, li_Trend, fd_Deviation);
    }
    //----    1- 
    else
    {
        for (li_IND = 0; li_IND < 2; li_IND++)
        {lda_MA[li_IND] = iCustom (fs_Symbol, fi_TF, "AllAverages_v2.51", fi_TF, MA_Period, MA_Shift, MA_Method, MA_Price, Color_Mode, 0, li_BAR + li_IND);}
        double ld_Price = fGet_PriceOnBar (PRICE_TYPICAL, fs_Symbol, fi_TF, li_BAR);
        //----  1-     
        ld_Deviation = fControl_Deviation (lda_MA, lb_Condition, li_cmd, li_Trend, fd_Deviation);
        if (NDD (li_cmd * (lda_MA[0] - ld_Price)) >= 0.0) return (STOP);
    }
    //----          - 
    if (ld_Deviation == 0.0) return (STOP);
    int li_cnt = 0;
    while (lb_Condition == true)
    {
        li_BAR++;
        //----     
        if (lb_twice)
        {
            for (li_IND = 0; li_IND < 2; li_IND++)
            {lda_MA[li_IND] = iCustom (fs_Symbol, fi_TF, "AllAverages_v2.51", fi_TF, bia_PeriodMA[li_IND], MA_Shift, MA_Method, MA_Price, Color_Mode, 0, li_BAR);}
            bool lb_AddCondition = true;
            li_cnt++;
        }
        else
        {
            for (li_IND = 0; li_IND < 2; li_IND++)
            {lda_MA[li_IND] = iCustom (fs_Symbol, fi_TF, "AllAverages_v2.51", fi_TF, MA_Period, MA_Shift, MA_Method, MA_Price, Color_Mode, 0, li_BAR + li_IND);}
            ld_Price = fGet_PriceOnBar (PRICE_TYPICAL, fs_Symbol, fi_TF, li_BAR);
            lb_AddCondition = (NDD (li_cmd * (lda_MA[0] - ld_Price)) < 0.0);
        }
        //----      1- 
        ld_Deviation = NDD (lda_MA[0] - lda_MA[1]);
        //----        
        if (li_Trend == BULL) lb_Condition = (ld_Deviation >= 0.0); else lb_Condition = (ld_Deviation <= 0.0);
        //----   ,     
        if (lb_AddCondition)
        {
            if (fd_Deviation != 0.0) {if (MathAbs (ld_Deviation) >= fd_Deviation) li_VerificationBars++;}
            else li_VerificationBars++;
        }
        else li_cnt++;
        //----      
        if (!fb_ControlBeginChangeTrend) {if (li_VerificationBars == fi_VerificationBars) return (li_Trend);}
        else
        {
            //----  ,      , > fi_VerificationBars - 
            if (li_VerificationBars > fi_VerificationBars) {li_preSignal = STOP; return (STOP);}
            else if (!lb_Condition)
            {
                if (li_VerificationBars == fi_VerificationBars)
                {
                    if (bb_VisualControl) if (li_preSignal != li_Trend)
                    {
                        li_preSignal = li_Trend;
                        string lsa_Name[] = {"MA_UP[","MA_DW["};
                        color  lca_color[] = {Blue,Red};
                        int    lia_arrow[] = {236,238};
                        if (fSet_SignalAtArrow ("MA_", lia_arrow[li_Trend], lsa_Name[li_Trend] + (li_BAR - fi_BarSignal) + "]", 1, lca_color[li_Trend], Time[li_BAR], lda_MA[0], 0))
                        {Print ("MA[", TimeToStr (Time[li_BAR]), "]:  - ", fGet_NameOP (li_Trend));}
                        else Print ("  ", fGet_NameOP (li_Trend), " !!!");
                    }
                    return (li_Trend);
                }
                //----             - 
                else if (li_VerificationBars < fi_VerificationBars) return (STOP);
            }
        }
        //----     (  )
        if (li_cnt > MA_Period) return (STOP);
    }
//----
    return (STOP);
}
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
//|   : TarasBY, taras_bulba@tut.by                                              |
//+-----------------------------------------------------------------------------------+
//|          2-    1-                   |
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
double fControl_Deviation (double ar_MA[],           //   
                           bool& fb_Condition,       //  
                           int& fi_cmd,              // " "
                           int& fi_Trend,            // 
                           double fd_Deviation = 0)  //  \ 
{
    double ld_Deviation = NDD (ar_MA[0] - ar_MA[1]);
//----
    //----          - 
    if (ld_Deviation == 0.0) return (0.0);
    //----      ( )
    if (fd_Deviation != 0.0) {if (MathAbs (ld_Deviation) < fd_Deviation) return (0.0);}
    if (ld_Deviation > 0.0) {fb_Condition = (ld_Deviation >= 0.0); fi_Trend = BULL;}
    else {fb_Condition = (ld_Deviation <= 0.0); fi_Trend = BEAR; fi_cmd = -1;}
//----
    return (ld_Deviation);
}
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+

